########################################################################################
# Experiment 1 No evidence for feature overwriting in visual working memory (2013)
# built under R version 2.15.0
# Reinhold Kliegl & Elisabeth Jnger
############################################################################################################
library(reshape)
library(lattice)
library(ggplot2)
library(lme4)
library(MASS)
library(languageR)	
set.seed(1234321)

# data path (choose the right path)
setwd("C:/Users/Elisabeth/Desktop/PMR2/Experiment1")

# load data
Rohdaten<- read.table("data1.txt", header = TRUE);

## summary data
dim(Rohdaten)
head(Rohdaten)
summary(Rohdaten[,c(1,3,5,6,27)])

#################################################################################################################
## variable that shows which feature was changed in the probe(0=none,1=shape, 2=texture, 3=colour)...
gewechseltesMerkmal<-array(4:5444,dim=c(5440,1))
Rohdaten$gewechseltesMerkmal<-gewechseltesMerkmal

## variable that shows how much non-repeated features are in the probe(0-3)
festeMerkmale<-array(4:5444,dim=c(5440,1))
Rohdaten$festeMerkmale<-festeMerkmale

attach(Rohdaten)
## show which features was changed
gewechseltesMerkmal[P_Typ == 1]<- 0;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 1) & (P_Form!= I1_Form)]<-1;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 1) & (P_Textur!= I1_Textur)]<-2;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 1) & (P_Farbe!= I1_Farbe)]<-3;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 2) & (P_Form!= I2_Form)]<-1;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 2) & (P_Textur!= I2_Textur)]<-2;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 2) & (P_Farbe!= I2_Farbe)]<-3;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 3) & (P_Form!= I3_Form)]<-1;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 3) & (P_Textur!= I3_Textur)]<-2;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 3) & (P_Farbe!= I3_Farbe)]<-3;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 4) & (P_Form!= I4_Form)]<-1;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 4) & (P_Textur!= I4_Textur)]<-2;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 4) & (P_Farbe!= I4_Farbe)]<-3;
Rohdaten$gewechseltesMerkmal<-gewechseltesMerkmal
detach(Rohdaten)
####################################################################################################################################
attach(Rohdaten)
## number non- repeated features (feste Merkmale)... 
## control condition (no repeated features)
festeMerkmale[Bedingung==1]<-3
Rohdaten$festeMerkmale<-festeMerkmale

## Experimentalbedingung... zunchst positive Probes... knnen 1 oder 2 nicht wiederholte Merkmale haben...
festeMerkmale[(Bedingung==2&P_Typ==1)&(P_Ort==1&(((I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form) & ((I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
								((I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe) & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==1)&(P_Ort==2&(((I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form) & ((I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
								((I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==1)&(P_Ort==3&(((I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form) & ((I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)|(I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)))|
								((I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe) & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==1)&(P_Ort==4&(((I4_Form==I2_Form|I4_Form==I3_Form|I1_Form==I4_Form) & ((I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur)|(I4_Farbe==I2_Farbe|I4_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
								((I4_Farbe==I2_Farbe|I4_Farbe==I3_Farbe|I1_Farbe==I4_Farbe) & (I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur))))]<-1
Rohdaten$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung==2 & P_Typ==1) & festeMerkmale!=1]<-2
Rohdaten$festeMerkmale<-festeMerkmale

## negative probes with 3, 2 or 1 non-repeated features
festeMerkmale[(Bedingung==2&P_Typ==2)&(P_Ort==1&((gewechseltesMerkmal==1 & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur) & (I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe) & (I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form) & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==2)&(P_Ort==2&((gewechseltesMerkmal==1 & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur) & (I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form) & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==2)&(P_Ort==3&((gewechseltesMerkmal==1 & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur) & (I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe) & (I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form) & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==2)&(P_Ort==4&((gewechseltesMerkmal==1 & (I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur) & (I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form) & (I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-1
Rohdaten$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung==2&P_Typ==2&festeMerkmale!=1)&(P_Ort==1&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
											(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)|(I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)))|
											(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)|(I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==2&festeMerkmale!=1)&(P_Ort==2&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
											(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)))|
											(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==2&festeMerkmale!=1)&(P_Ort==3&((gewechseltesMerkmal==1 & ((I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)|(I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)))|
											(gewechseltesMerkmal==2 & ((I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)|(I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)))|
											(gewechseltesMerkmal==3 & ((I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)|(I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==2&festeMerkmale!=1)&(P_Ort==4&((gewechseltesMerkmal==1 & ((I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
											(gewechseltesMerkmal==2 & ((I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)))|
											(gewechseltesMerkmal==3 & ((I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
Rohdaten$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung==2 & P_Typ==2) & (festeMerkmale!=2 & festeMerkmale!=1)]<-3
Rohdaten$festeMerkmale<-festeMerkmale

### swap probes type 3 (repeated feature was switched to non-repeated)...
festeMerkmale[(Bedingung==2&P_Typ==3)&(P_Ort==1&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)|(I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)|(I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==3)&(P_Ort ==2&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==3)&(P_Ort==3&((gewechseltesMerkmal==1 & ((I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)|(I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)|(I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)|(I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==3)&(P_Ort==4&((gewechseltesMerkmal==1 & ((I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
Rohdaten$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung==2 & P_Typ==3) & festeMerkmale!=2]<-3
Rohdaten$festeMerkmale<-festeMerkmale

## gemischte Probes Typ 4 (nicht wiederholtes Merkmal zu wiederholtem Merkmal)...
festeMerkmale[(Bedingung==2&P_Typ==4)&(P_Ort==1&((gewechseltesMerkmal==1 & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur) & (I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe) & (I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form) & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur))))]<-0
festeMerkmale[(Bedingung==2&P_Typ==4)&(P_Ort==2&((gewechseltesMerkmal==1 & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur) & (I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form) & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-0
festeMerkmale[(Bedingung==2&P_Typ==4)&(P_Ort==3&((gewechseltesMerkmal==1 & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur) & (I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe) & (I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form) & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur))))]<-0
festeMerkmale[(Bedingung==2&P_Typ==4)&(P_Ort==4&((gewechseltesMerkmal==1 & (I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur) & (I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form) & (I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-0
Rohdaten$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung == 2 & P_Typ==4) & festeMerkmale!=0]<-1
Rohdaten$festeMerkmale<-festeMerkmale
detach(Rohdaten)
rm(festeMerkmale,gewechseltesMerkmal)

#################################################################################################################
# analyses
################################################################################################################################
rm(list=ls())
data <- read.table("data1.txt", header=TRUE)

data$id <- factor(data$Vpn)
data$sex <- factor(data$Geschlecht)
data$Abi <- factor(data$Abi)
data$farbschwach <- factor(data$farbschwach)   
data$item <- factor(data$Aufgabe)              # item
data$Bedingung <- factor(data$Bedingung, labels=c("C", "E"))
data$P_Ort <- factor(data$P_Ort)

# 3 different probes for control, but 4 different probes for experimental condition
data$P_Typ <- ifelse(data$P_Typ==4 & data$Bedingung =="C", 3, data$P_Typ)  
table(data$P_Typ, data$Bedingung)              # check

# New factor cond with 7 levels, keep 4 probe types for experimental condition
data$cond <- factor(paste(data$Bedingung, data$P_Typ, sep="_"))

table(data$id, data$cond)                     # checks
table(data$id, data$cond, data$P_Ort)         # not balanced by position, obviously

### Contrast  
cmat <- matrix(c( 1/3,  1/3,  1/3, -1/3, -1/3, -1/3,    0,        # E -C(restricted)
                   1,   -1,    0,    1,   -1,    0,    0,         # pos -neg.new
                   0,    1,   -1,    0,    1,   -1,    0,         # neg.new- neg.swap1
                   1,   -1,    0,   -1,    1,    0,    0,         # E-C x pos-neg.new
                   0,    1,   -1,    0,   -1,  + 1,    0,         # E-C xneg.new - neg.swap1
                   0,    0,    0,    0,    0,    1,   -1), 7, 6)  #neg.swap1 - neg.swap2
table(data$P_Typ, data$Bedingung) 

cmat.inv <- fractions(ginv(t(cmat)))
contrasts(data$cond) <- cmat.inv

### GLMM
print(m1 <- lmer(korrekt ~ cond + (1 | id), family=binomial, data=data), cor=F)

# ... leave out neg-swap1 vs. neg-swap2 contrast (6th contrast)
# contrasts(data$cond, 5) <- cmat.inv
# print(m1a<- lmer(korrekt ~ cond + (1 | id), family=binomial, REML=FALSE, data=data), cor=F)
# anova(m1, m1a) # m1 besser

### LMM
print(m2 <- lmer(korrekt ~ cond + (1 | id), data=data), cor = F)
# ... same results as GLMM with advantage that coefficients estimate accuracy differences in prob metric

####################################################################################
### Graphics 
# PC accross conditions
# Aggregate to Subject x Cond  cells 
data.id <- cast(data, value="korrekt", id + Bedingung + P_Typ  ~ ., function(x) c(PC=mean(x), N=length(x)) )

# Removing Between-Subject Variance 
# Remove between-subject variance for error bars  
GM <- mean(data.id$PC)
data.id <- ddply(data.id, .(id), transform, PC.w = PC - mean(PC) + GM)  

# checks
mean(data.id$PC); mean(data.id$PC.w); sd(data.id$PC); sd(data.id$PC.w)

# means
# experimental vs. control condition
cast(data.id, value="PC", Bedingung ~ ., function(x) c(M=round(mean(x),2)))

# all probe- types
cast(data.id, value="PC", P_Typ ~ Bedingung, function(x) c(M=round(mean(x),2)))

####  Graphics  
# Means, standard deviation, n of observations per cell, standard error
(M1 <- cast(data.id, value="PC.w", Bedingung + P_Typ ~ . , 
	        function(x) c(PC = mean(x), 
	                     SD = sd(x), 
	                      N = length(x), 
	                     SE = signif(sd(x)/sqrt(length(x)), 2) ) ))
names(M1)[1] <- "Condition"
levels(M1$Condition) <- c("control", "experimental")

M1$P_Typ <- factor(M1$P_Typ)
levels(M1$P_Typ) <- c("positive", "negative\nnew", "negative\nswap 1", "negative\nswap 2")

# Plot
(p1 <- qplot(data=M1, x=P_Typ, y=PC, shape=Condition, group=Condition,  
      xlab="Probe Type", ylab="Proportion Correct", main = "(a) Accuracy", ylim = c(0.40,1.00), geom=c("point", "line") ) +
      scale_linetype_discrete("Condition") +
	theme_bw() +
      geom_errorbar(aes(max = PC + 1*SE, min = PC - 1*SE), width=.1) +  geom_point(size=3) )
###############################################################################################
# Position curves
### Aggregate to Subject x Cond  cells 
data1<-data[data$P_Typ!=1,]
data1.id <- cast(data1, value="korrekt", id + Bedingung+ P_Ort  ~ ., function(x) c(PC=mean(x), N=length(x)) )

#### Removing Between-Subject Variance 
# ... remove between-subject variance for error bars  
GM <- mean(data1.id$PC)
data1.id <- ddply(data1.id, .(id), transform, PC.w = PC - mean(PC) + GM)  

# checks
mean(data1.id$PC); mean(data1.id$PC.w); sd(data1.id$PC); sd(data1.id$PC.w)

###  Graphics  
# Means, standard deviation, n of observations per cell, standard error
(M1 <- cast(data1.id, value="PC.w", Bedingung + P_Ort ~ . , 
	        function(x) c(PC = mean(x), 
	                     SD = sd(x), 
	                      N = length(x), 
	                     SE = signif(sd(x)/sqrt(length(x)), 2) ) ))
names(M1)[1] <- "Condition"
levels(M1$Condition) <- c("control", "experimental")

M1$P_Ort <- factor(M1$P_Ort)
levels(M1$P_Ort) <- c("position1", "position2", "position3", "position4")

# Plot
(p1 <- qplot(data=M1[], x=P_Ort, y=PC, shape=Condition, group=Condition,  
      xlab="Probe Type", ylab="Proportion Correct",main = "(a) Accuracy", ylim = c(0.40,1.00), geom=c("point", "line") ) +
      scale_linetype_discrete("Condition") +
      theme_bw()+
	geom_errorbar(aes(max = PC + 1*SE, min = PC - 1*SE), width=.1) +  geom_point(size=3) )

########################### REACTION TIMES #################################################

rm(list=ls())
data <- read.table("data1.txt", header=TRUE)  # Identical with "Daten_angepasst.txt"

data$id <- factor(data$Vpn)
data$sex <- factor(data$Geschlecht)
data$Abi <- factor(data$Abi)
data$farbschwach <- factor(data$farbschwach)   
data$item <- factor(data$Aufgabe)             # item
data$Bedingung <- factor(data$Bedingung, labels=c("C", "E"))
data$P_Ort <- factor(data$P_Ort)

# 3 different probes for control, but 4 different probes for exp condition
data$P_Typ <- ifelse(data$P_Typ==4 & data$Bedingung =="C", 3, data$P_Typ)  
table(data$P_Typ, data$Bedingung)             # check

# New factor cond with 7 levels, keep 4 probe types for experimental condition
data$cond <- factor(paste(data$Bedingung, data$P_Typ, sep="_"))

table(data$id, data$cond)                     # checks
table(data$id, data$cond, data$P_Ort)         # not balanced by position, obviously

# Filter
dat <- subset(data, korrekt==1)

# Transform
boxcox(RZ ~ id*cond, data=dat)     # lambda = -0.5
dat$lrt <- log(dat$RZ)
dat$srt <- -1/sqrt(dat$RZ)       
dat$rrt <- -1/dat$RZ

boxplot(lrt ~ id*cond, dat)        
boxplot(srt ~ id*cond, dat)        # That's indeed the best transformation
boxplot(rrt ~ id*cond, dat)        

# Contrast  
cmat <- matrix(c( 1/3,  1/3,  1/3, -1/3, -1/3, -1/3,    0,        # E -C(restricted)
                   1,   -1,    0,    1,   -1,    0,    0,         # pos -neg.new
                   0,    1,   -1,    0,    1,   -1,    0,         # neg.new- neg.swap1
                   1,   -1,    0,   -1,    1,    0,    0,         # E-C x pos-neg.new
                   0,    1,   -1,    0,   -1,  + 1,    0,         # E-C xneg.new - neg.swap1
                   0,    0,    0,    0,    0,    1,   -1), 7, 6)  #neg.swap1 - neg.swap2
table(dat$P_Typ, dat$Bedingung) 

cmat.inv <- fractions(ginv(t(cmat)))
contrasts(dat$cond) <- cmat.inv

### LMM
print(m1.lrt <- lmer(lrt ~ cond + (1 | id), data=dat), cor=F)
print(m1 <- lmer(srt ~ cond + (1 | id), data=dat), cor=F)
print(m1.rrt <- lmer(rrt ~ cond + (1 | id), data=dat), cor=F)

### Residuals
qqmath(resid(m1))

# leave out neg-swap1 vs. neg-swap2 contrast (6th contrast)
print(m1.ML <- lmer(srt ~ cond + (1 | id), REML=FALSE, data=dat), cor=F)

contrasts(dat$cond, 5) <- cmat.inv
print(m1a.ML <- lmer(srt ~ cond + (1 | id), REML=FALSE, data=dat), cor=F)
anova(m1.ML, m1a.ML)

###################### RAW DATA (no transform) ################################
### Aggregate to Subject x Cond  cells 
data.id <- cast(dat, value="RZ", id + Bedingung + P_Typ  ~ ., function(x) c(RT=mean(x), N=length(x)) )

### Removing Between-Subject Variance 
# Remove between-subject variance for error bars  
GM <- mean(data.id$RT)
data.id <- ddply(data.id, .(id), transform, RT.w = RT - mean(RT) + GM)  

# checks
mean(data.id$RT); mean(data.id$RT.w); sd(data.id$RT); sd(data.id$RT.w)

# Mittelwerte
# E vs. C
cast(data.id, value="RT", Bedingung ~ ., function(x) c(M=mean(x),2))

# alle Probe- Typen
cast(data.id, value="RT", P_Typ ~ Bedingung, function(x) c(M=mean(x),2))

#########################################################################
### Graphics  
# Means, standard deviation, n of observations per cell, standard error
(M1.rt <- cast(data.id, value="RT.w", Bedingung + P_Typ ~ . , 
	        function(x) c(RT = mean(x), 
	                      SD = sd(x), 
	                       N = length(x), 
	                      SE = signif(sd(x)/sqrt(length(x)), 2) ) ))
names(M1.rt)[1] <- "Condition"
levels(M1.rt$Condition) <- c("control", "experimental")

M1.rt$P_Typ <- factor(M1.rt$P_Typ)
levels(M1.rt$P_Typ) <- c("positive", "negative\nnew", "negative\nswap 1", "negative\nswap 2")

# Plot
(p2 <- qplot(data=M1.rt, x=P_Typ, y=RT, shape=Condition, group=Condition,  
      xlab="Probe Type", ylab="Reaction Time [s]", main = "(b) Correct RTs", ylim=c(0.8,1.5), geom=c("point", "line") ) +
      scale_linetype_discrete("Condition") +
      theme_bw() +
	geom_errorbar(aes(max = RT + 1*SE, min = RT - 1*SE), width=.1) +  geom_point(size=3) )

###############################################################################################
# Position curves
### Aggregate to Subject x Cond  cells 
data1<-dat[dat$P_Typ!=1,]
data1.id <- cast(data1, value="RZ", id + Bedingung + P_Ort  ~ ., function(x) c(RZ=mean(x), N=length(x)) )

### Removing Between-Subject Variance 
# Remove between-subject variance for error bars  
GM <- mean(data1.id$RZ)
data1.id <- ddply(data1.id, .(id), transform, RZ.w = RZ - mean(RZ) + GM)  

# checks
mean(data1.id$RZ); mean(data1.id$RZ.w); sd(data1.id$RZ); sd(data1.id$RZ.w)

##################################################################################
### Graphics  
# Means, standard deviation, n of observations per cell, standard error
(M1 <- cast(data1.id, value="RZ.w", Bedingung + P_Ort ~ . , 
	        function(x) c(RZ = mean(x), 
	                     SD = sd(x), 
	                      N = length(x), 
	                     SE = signif(sd(x)/sqrt(length(x)), 2) ) ))
names(M1)[1] <- "Condition"
levels(M1$Condition) <- c("control", "experimental")

M1$P_Ort <- factor(M1$P_Ort)
levels(M1$P_Ort) <- c("position1", "position2", "position3", "position4")

# Plot
(p1 <- qplot(data=M1, x=P_Ort, y=RZ, shape=Condition, group=Condition,  
      xlab="Probe Type", ylab="Reaction Time [s]", main="(b) Correct RTs", ylim=c(0.8,1.5),geom=c("point", "line") ) +
      scale_linetype_discrete("Condition") +
	theme_bw() +
      geom_errorbar(aes(max = RZ + 1*SE, min = RZ - 1*SE), width=.1) +  geom_point(size=3) )
##################################################################################
# This is the end.
###############################################################################