########################################################################################
# Experiment 2 No evidence for feature overwriting in visual working memory (2013)
# built under R version 2.15.0
# Reinhold Kliegl & Elisabeth Jnger
############################################################################################################
library(reshape)
library(lattice)
library(MASS)
library(ggplot2)  
library(lme4)
library(languageR)	
set.seed(1234321)

# data path (choose the right path)
setwd("C:/Users/Elisabeth/Desktop/PMR2/Experiment2")

# read in data...
Rohdaten<- read.table("data2.txt", header = FALSE);
Rohdaten<-as.data.frame(Rohdaten)
colnames(Rohdaten) = c("Vpn","Geschlecht","Alter","Ausbildung","WT","ZST","farbschwach","Nr", "Bed","P_Bed","P_Ort","I1_Form","I1_Farbe","I1_Textur","I2_Form","I2_Farbe","I2_Textur","I3_Form","I3_Farbe","I3_Textur","I4_Form","I4_Farbe","I4_Textur","P_Form","P_Farbe","P_Textur","RZ","korr")
summary(Rohdaten[,c(1,3,5,6,27)])

############################################################################################################
attach(Rohdaten)
## find correct location of probed item ("E_pos" = Bed 2 & P_Bed 1 sowie "E_neu" = Bed 2 & P_Bed 2)
P_Ort[(Bed ==2 & P_Bed== 1) & (P_Form == I1_Form & P_Farbe == I1_Farbe & P_Textur == I1_Textur)]<-1;
P_Ort[(Bed ==2 & P_Bed== 1) & (P_Form == I2_Form & P_Farbe == I2_Farbe & P_Textur == I2_Textur)]<-2;
P_Ort[(Bed ==2 & P_Bed== 1) & (P_Form == I3_Form & P_Farbe == I3_Farbe & P_Textur == I3_Textur)]<-3;
P_Ort[(Bed ==2 & P_Bed== 1) & (P_Form == I4_Form & P_Farbe == I4_Farbe & P_Textur == I4_Textur)]<-4;

P_Ort[(Bed ==2 & P_Bed== 2) & ((P_Form == I1_Form & P_Farbe == I1_Farbe)| (P_Form == I1_Form & P_Textur == I1_Textur)|(P_Farbe == I1_Farbe & P_Textur == I1_Textur))]<-1;
P_Ort[(Bed ==2 & P_Bed== 2) & ((P_Form == I2_Form & P_Farbe == I2_Farbe)| (P_Form == I2_Form & P_Textur == I2_Textur)|(P_Farbe == I2_Farbe & P_Textur == I2_Textur))]<-2;
P_Ort[(Bed ==2 & P_Bed== 2) & ((P_Form == I3_Form & P_Farbe == I3_Farbe)| (P_Form == I3_Form & P_Textur == I3_Textur)|(P_Farbe == I3_Farbe & P_Textur == I3_Textur))]<-3;
P_Ort[(Bed ==2 & P_Bed== 2) & ((P_Form == I4_Form & P_Farbe == I4_Farbe)| (P_Form == I4_Form & P_Textur == I4_Textur)|(P_Farbe == I4_Farbe & P_Textur == I4_Textur))]<-4;
Rohdaten$P_Ort<-P_Ort
detach (Rohdaten)
############################################################################################################

## variable that shows which features was changed in the probe (0=none,1=shape, 2=texture, 3=colour)...
gewechseltesMerkmal<-array(4:5804,dim=c(5800,1))
Rohdaten$gewechseltesMerkmal<-gewechseltesMerkmal

## variable that shows how much non-repeated features are in the probe (0-3)
festeMerkmale<-array(4:5804,dim=c(5800,1))
Rohdaten$festeMerkmale<-festeMerkmale

attach(Rohdaten)
## changed features
gewechseltesMerkmal[P_Bed == 1]<- 0;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 1) & (P_Form!= I1_Form)]<-1;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 1) & (P_Textur!= I1_Textur)]<-2;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 1) & (P_Farbe!= I1_Farbe)]<-3;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 2) & (P_Form!= I2_Form)]<-1;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 2) & (P_Textur!= I2_Textur)]<-2;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 2) & (P_Farbe!= I2_Farbe)]<-3;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 3) & (P_Form!= I3_Form)]<-1;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 3) & (P_Textur!= I3_Textur)]<-2;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 3) & (P_Farbe!= I3_Farbe)]<-3;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 4) & (P_Form!= I4_Form)]<-1;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 4) & (P_Textur!= I4_Textur)]<-2;
gewechseltesMerkmal[(P_Bed!=1 & P_Ort== 4) & (P_Farbe!= I4_Farbe)]<-3;
Rohdaten$gewechseltesMerkmal<-gewechseltesMerkmal
detach(Rohdaten)
############################################################################################################
attach(Rohdaten)
## non-repeated features... 
## control condition and positive probes of experimental condition
festeMerkmale[Bed==1]<-3
festeMerkmale[Bed==2 & P_Bed ==1]<-2
Rohdaten$festeMerkmale<-festeMerkmale

## new probes experimental condition (3)
festeMerkmale[(Bed==2 & P_Bed==2)] <-3
Rohdaten$festeMerkmale<-festeMerkmale

## swap probes type 3 (repeated switched to non-repeated)...
festeMerkmale[(Bed==2&P_Bed==3)&(P_Ort==1&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)|(I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)|(I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bed==2&P_Bed==3)&(P_Ort ==2&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bed==2&P_Bed==3)&(P_Ort==3&((gewechseltesMerkmal==1 & ((I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)|(I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)|(I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)|(I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bed==2&P_Bed==3)&(P_Ort==4&((gewechseltesMerkmal==1 & ((I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
Rohdaten$festeMerkmale<-festeMerkmale
festeMerkmale[(Bed==2 & P_Bed==3) & festeMerkmale!=2]<-3
Rohdaten$festeMerkmale<-festeMerkmale
detach(Rohdaten)
rm(festeMerkmale,gewechseltesMerkmal)

Rohdaten<-as.data.frame(Rohdaten)
############################################################################################################
# analyses
################################################################################################################################
data <- Rohdaten
data$P_Bed[Rohdaten$Bed==2 & Rohdaten$P_Bed==3 & Rohdaten$festeMerkmale==2]<-4
data$id <- factor(data$Vpn)
data$sex <- factor(data$Geschlecht)
data$farbschwach <- factor(data$farbschwach)   
data$Bedingung <- factor(data$Bed, labels=c("C", "E"))
data$P_Ort <- factor(data$P_Ort)
table(data$P_Bed, data$Bedingung)              # check

# New factor cond with 7 levels, keep 4 probe types for experimental condition
data$cond <- factor(paste(data$Bedingung, data$P_Bed, sep="_"))

table(data$id, data$cond)                     # checks
table(data$id, data$cond, data$P_Ort)         # not balanced by position, obviously

### Contrasts 
cmat <- matrix(c( 1/3,  1/3,  1/3, -1/4, -1/4, -1/4, -1/4,     # E - C
                    1,   -1,    0,    1,   -1,    0,    0,     # pos - neg.new
                    0,    1,   -1,    0,    1, -1/2, -1/2,     # neg.new - neg.swap
                    1,   -1,    0,   -1,    1,    0,    0,     # E-C x pos-neg.new
                    0,    1,   -1,    0,   -1, +1/2, +1/2,     # E-C x pos-neg.swap 
                    0,    0,    0,    0,    0,    1,   -1), 7, 6)  #  neg.swap1 - neg.swap2


cmat.inv <- fractions(ginv(t(cmat)))
contrasts(data$cond) <- cmat.inv

# GLMM
print(m1 <- lmer(korr ~ cond + (1 | id), family=binomial, data=data),cor=F)

# LMM
print(m2 <- lmer(korr ~ cond + (1 | id), data=data), cor = F)
# ... same results as GLMM with advantage that coefficients estimate accuracy differences in prob metric

### Aggregate to Subject x Cond  cells
data.id <- cast(data, value="korr", id + Bedingung + P_Bed  ~ ., function(x) c(PC=mean(x), N=length(x)) )

### Removing Between-Subject Variance 
# ... remove between-subject variance for error bars  
GM <- mean(data.id$PC)
data.id <- ddply(data.id, .(id), transform, PC.w = PC - mean(PC) + GM)  

# checks
mean(data.id$PC); mean(data.id$PC.w); sd(data.id$PC); sd(data.id$PC.w)

# means
# Experimental vs. control
cast(data.id, value="PC", Bedingung ~ ., function(x) c(M=round(mean(x),2)))

# all probe types
cast(data.id, value="PC", P_Bed ~ Bedingung, function(x) c(M=mean(x),2))

################################################################################
###  Graphics
# Means, standard deviation, n of observations per cell, standard error
(M1 <- cast(data.id, value="PC.w", Bedingung + P_Bed ~ . , 
	        function(x) c(PC = mean(x), 
	                     SD = sd(x), 
	                      N = length(x), 
	                     SE = signif(sd(x)/sqrt(length(x)), 2) ) ))
names(M1)[1] <- "Condition"
levels(M1$Condition) <- c("control", "experimental")

M1$P_Bed <- factor(M1$P_Bed)
levels(M1$P_Bed) <- c("positive", "negative\nnew", "negative\nswap (1:1:1)", "negative\nswap (2:1:1)")

# Plot
theme_update(grid.colour = "black",grid.fill="white")
#ggtheme(theme_bw)
(p1 <- qplot(data=M1, x=P_Bed, y=PC, shape=Condition, group=Condition,  
      xlab="Probe Type", ylab="Proportion Correct", main = "(a) Accuracy", ylim=c(0.4,1.0), geom=c("point", "line") ) +
      theme_bw()+
	scale_linetype_discrete("Condition") +
      geom_errorbar(aes(max = PC + 1*SE, min = PC - 1*SE), width=.1) +  geom_point(size=3) )

########################## REACTION TIMES ##################################
data <- Rohdaten

data$P_Bed[data$Bed==2 & data$P_Bed==3 & data$festeMerkmale==2]<-4
data$P_Typ<-factor(data$P_Bed)
data$id <- factor(data$Vpn)
data$Bedingung <- factor(data$Bed, labels=c("C", "E"))
data$P_Ort <- factor(data$P_Ort)

table(data$P_Typ, data$Bedingung)              # check

# New factor cond with 7 levels, keep 4 probe types for experimental condition
data$cond <- factor(paste(data$Bedingung, data$P_Typ, sep="_"))

table(data$id, data$cond)                     # checks
table(data$id, data$cond, data$P_Ort)         # not balanced by position, obviously

# Filter
dat <- subset(data, korr==1)

# Transform
boxcox(RZ ~ id*cond, data=dat)     # lambda = -0.5
dat$lrt <- log(dat$RZ)
dat$srt <- -1/sqrt(dat$RZ)       
dat$rrt <- -1/dat$RZ

boxplot(lrt ~ id*cond, dat)        
boxplot(srt ~ id*cond, dat)        # That's indeed the best transformation
boxplot(rrt ~ id*cond, dat)        

###  Contrast  
cmat <- matrix(c( 1/3,  1/3,  1/3, -1/4, -1/4, -1/4, -1/4,         # E - C
                    1,   -1,    0,    1,   -1,    0,    0,         # pos - neg.new
                    0,    1,   -1,    0,    1, -1/2, -1/2,         # neg.new - neg.swap
                    1,   -1,    0,   -1,    1,    0,    0,         # E-C x pos-neg.new
                    0,    1,   -1,    0,   -1, +1/2, +1/2,         # E-C x neg.new-neg.swap 
                    0,    0,    0,    0,    0,    1,   -1), 7, 6)  # neg.swap1 - neg.swap2


cmat.inv <- fractions(ginv(t(cmat)))
contrasts(dat$cond) <- cmat.inv

### LMM
print(m1.lrt <- lmer(lrt ~ cond + (1 | id), data=dat), cor=F)
print(m1 <- lmer(srt ~ cond + (1 | id), data=dat), cor=F)
print(m1.rrt <- lmer(rrt ~ cond + (1 | id), data=dat), cor=F)
qqmath(resid(m1))

tapply((dat$RZ), dat$P_Typ, mean)

# Leave out neg-swap1 vs. neg-swap2 contrast (6th contrast)
print(m1.ML <- lmer(srt ~ cond + (1 | id), REML=FALSE, data=dat), cor=F)

contrasts(dat$cond, 5) <- cmat.inv
print(m1a.ML <- lmer(srt ~ cond + (1 | id), REML=FALSE, data=dat), cor=F)
anova(m1.ML, m1a.ML)

###################### RAW DATA (no transform) ################################
### Aggregate to Subject x Cond  cells
data.id <- cast(dat, value="RZ", id + Bedingung + P_Typ  ~ ., function(x) c(RT=mean(x), N=length(x)) )

### Removing between-subject Variance for error bars  
GM <- mean(data.id$RT)
data.id <- ddply(data.id, .(id), transform, RT.w = RT - mean(RT) + GM)  

# checks
mean(data.id$RT); mean(data.id$RT.w); sd(data.id$RT); sd(data.id$RT.w)

# means
# Experimental vs. control
cast(data.id, value="RT", Bedingung ~ ., function(x) c(M=round(mean(x),2)))

# all probe- types
cast(data.id, value="RT", P_Typ ~ Bedingung, function(x) c(M=mean(x),2))

###############################################################################
####  Graphics
# Means, standard deviation, n of observations per cell, standard error
(M1.rt <- cast(data.id, value="RT.w", Bedingung + P_Typ ~ . , 
	        function(x) c(RT = mean(x), 
	                      SD = sd(x), 
	                       N = length(x), 
	                      SE = signif(sd(x)/sqrt(length(x)), 2) ) ))
names(M1.rt)[1] <- "Condition"
levels(M1.rt$Condition) <- c("control", "experimental")

M1.rt$P_Typ <- factor(M1.rt$P_Typ)
levels(M1.rt$P_Typ) <- c("positive", "negative\nnew", "negative\nswap(1:1:1)", "negative\nswap(2:1:1)")

# Plot
(p2 <- qplot(data=M1.rt, x=P_Typ, y=RT, shape=Condition, group=Condition,  
      xlab="Probe Type", ylab="Reaction Time [s]",main="(b) Correct RTs", ylim=c(0.8,1.5), geom=c("point", "line") ) +
      scale_linetype_discrete("Condition") +
	theme_bw()+
      geom_errorbar(aes(max = RT + 1*SE, min = RT - 1*SE), width=.1) +  geom_point(size=3) )
################################################################
# Stop it.
################################################################

