########################################################################################
# Experiment 3 No evidence for feature overwriting in visual working memory (2013)
# built under R version 2.15.0
# Elisabeth Jnger
########################################################################################
rm(list=ls())
# lade Libraries... fr spezielle Funktionen...
library(reshape)
library(lattice)
library(ggplot2)
library(lme4)
library(MASS)
library(languageR)	
set.seed(1234321)

# data Experiment 1=> data path (choose the right path)
setwd("C:/Users/Elisabeth/Desktop/PMR2/Experiment1")
data1<- read.table("data1.txt", header = TRUE);
## Daten
dim(data1)
head(data1)

######################################################################
## variable that shows which feature was changed between probe and probed item (0=none,1=shape, 2=texture,3=colour)...
gewechseltesMerkmal<-array(4:5444,dim=c(5440,1))
data1$gewechseltesMerkmal<-gewechseltesMerkmal

## variable that shows how much non-repeated features in probe (0-3)
festeMerkmale<-array(4:5444,dim=c(5440,1))
data1$festeMerkmale<-festeMerkmale
attach(data1)

## changed features
gewechseltesMerkmal[P_Typ == 1]<- 0;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 1) & (P_Form!= I1_Form)]<-1;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 1) & (P_Textur!= I1_Textur)]<-2;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 1) & (P_Farbe!= I1_Farbe)]<-3;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 2) & (P_Form!= I2_Form)]<-1;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 2) & (P_Textur!= I2_Textur)]<-2;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 2) & (P_Farbe!= I2_Farbe)]<-3;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 3) & (P_Form!= I3_Form)]<-1;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 3) & (P_Textur!= I3_Textur)]<-2;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 3) & (P_Farbe!= I3_Farbe)]<-3;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 4) & (P_Form!= I4_Form)]<-1;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 4) & (P_Textur!= I4_Textur)]<-2;
gewechseltesMerkmal[(P_Typ!=1 & P_Ort== 4) & (P_Farbe!= I4_Farbe)]<-3;
data1$gewechseltesMerkmal<-gewechseltesMerkmal
detach(data1)
####################################################################################################################################
attach(data1)
## number non- repeated features (feste Merkmale)... 
## Control condition
festeMerkmale[Bedingung==1]<-3
data1$festeMerkmale<-festeMerkmale

## Experimental condition... positive Probes... 1 or 2 non-repeated features
festeMerkmale[(Bedingung==2&P_Typ==1)&(P_Ort==1&(((I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form) & ((I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
								((I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe) & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==1)&(P_Ort==2&(((I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form) & ((I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
								((I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==1)&(P_Ort==3&(((I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form) & ((I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)|(I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)))|
								((I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe) & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==1)&(P_Ort==4&(((I4_Form==I2_Form|I4_Form==I3_Form|I1_Form==I4_Form) & ((I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur)|(I4_Farbe==I2_Farbe|I4_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
								((I4_Farbe==I2_Farbe|I4_Farbe==I3_Farbe|I1_Farbe==I4_Farbe) & (I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur))))]<-1
data1$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung==2 & P_Typ==1) & festeMerkmale!=1]<-2
data1$festeMerkmale<-festeMerkmale

## negative probes 3, 2 or 1 non-repeated feature...
festeMerkmale[(Bedingung==2&P_Typ==2)&(P_Ort==1&((gewechseltesMerkmal==1 & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur) & (I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe) & (I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form) & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==2)&(P_Ort==2&((gewechseltesMerkmal==1 & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur) & (I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form) & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==2)&(P_Ort==3&((gewechseltesMerkmal==1 & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur) & (I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe) & (I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form) & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur))))]<-1
festeMerkmale[(Bedingung==2&P_Typ==2)&(P_Ort==4&((gewechseltesMerkmal==1 & (I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur) & (I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form) & (I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-1
data1$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung==2&P_Typ==2&festeMerkmale!=1)&(P_Ort==1&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
											(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)|(I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)))|
											(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)|(I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==2&festeMerkmale!=1)&(P_Ort==2&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
											(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)))|
											(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==2&festeMerkmale!=1)&(P_Ort==3&((gewechseltesMerkmal==1 & ((I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)|(I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)))|
											(gewechseltesMerkmal==2 & ((I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)|(I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)))|
											(gewechseltesMerkmal==3 & ((I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)|(I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==2&festeMerkmale!=1)&(P_Ort==4&((gewechseltesMerkmal==1 & ((I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
											(gewechseltesMerkmal==2 & ((I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)))|
											(gewechseltesMerkmal==3 & ((I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
data1$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung==2 & P_Typ==2) & (festeMerkmale!=2 & festeMerkmale!=1)]<-3
data1$festeMerkmale<-festeMerkmale

### swap probes type 3 (repeated to non-repeated)...
festeMerkmale[(Bedingung==2&P_Typ==3)&(P_Ort==1&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe)|(I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form)|(I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==3)&(P_Ort ==2&((gewechseltesMerkmal==1 & ((I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)|(I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==3)&(P_Ort==3&((gewechseltesMerkmal==1 & ((I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)|(I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe)|(I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form)|(I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur)))))]<-2
festeMerkmale[(Bedingung==2&P_Typ==3)&(P_Ort==4&((gewechseltesMerkmal==1 & ((I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur)|(I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)))|
								(gewechseltesMerkmal==2 & ((I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe)|(I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)))|
								(gewechseltesMerkmal==3 & ((I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form)|(I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur)))))]<-2
data1$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung==2 & P_Typ==3) & festeMerkmale!=2]<-3
data1$festeMerkmale<-festeMerkmale

### swap probes type 4 (non-repeated to repeated)...
festeMerkmale[(Bedingung==2&P_Typ==4)&(P_Ort==1&((gewechseltesMerkmal==1 & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur) & (I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I1_Farbe==I4_Farbe) & (I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I2_Form|I1_Form==I3_Form|I1_Form==I4_Form) & (I1_Textur==I2_Textur|I1_Textur==I3_Textur|I1_Textur==I4_Textur))))]<-0
festeMerkmale[(Bedingung==2&P_Typ==4)&(P_Ort==2&((gewechseltesMerkmal==1 & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur) & (I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I2_Farbe|I2_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I2_Form|I2_Form==I3_Form|I2_Form==I4_Form) & (I1_Textur==I2_Textur|I2_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-0
festeMerkmale[(Bedingung==2&P_Typ==4)&(P_Ort==3&((gewechseltesMerkmal==1 & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur) & (I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I3_Farbe==I2_Farbe|I1_Farbe==I3_Farbe|I3_Farbe==I4_Farbe) & (I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I3_Form==I2_Form|I1_Form==I3_Form|I3_Form==I4_Form) & (I3_Textur==I2_Textur|I1_Textur==I3_Textur|I3_Textur==I4_Textur))))]<-0
festeMerkmale[(Bedingung==2&P_Typ==4)&(P_Ort==4&((gewechseltesMerkmal==1 & (I4_Textur==I2_Textur|I4_Textur==I3_Textur|I1_Textur==I4_Textur) & (I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe))|
								(gewechseltesMerkmal==2 & (I1_Farbe==I4_Farbe|I4_Farbe==I3_Farbe|I2_Farbe==I4_Farbe) & (I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form))|
								(gewechseltesMerkmal==3 & (I1_Form==I4_Form|I4_Form==I3_Form|I2_Form==I4_Form) & (I1_Textur==I4_Textur|I4_Textur==I3_Textur|I2_Textur==I4_Textur))))]<-0
data1$festeMerkmale<-festeMerkmale
festeMerkmale[(Bedingung == 2 & P_Typ==4) & festeMerkmale!=0]<-1
data1$festeMerkmale<-festeMerkmale
detach(data1)
rm(festeMerkmale,gewechseltesMerkmal)

############################################################################
data1$id <- factor(data1$Vpn)
data1$Bedingung <- factor(data1$Bedingung, labels=c("C", "E"))
data1$P_Typ[data1$P_Typ==4]<-3
data1$P_Typ<-factor(data1$P_Typ, labels=c("positive", "new","swap"))

# ANOVAs
options(contrasts=c("contr.sum","contr.poly"))
data.PC <- cast(data1, value="korrekt", id + Bedingung + P_Typ  ~ ., function(x) c(PC=mean(x), N=length(x)) )
summary(a<-aov(PC ~ Bedingung*P_Typ+Error(id/(Bedingung*P_Typ)), data=data.PC))
print(model.tables(a,"means"),digits=3)
#different way
anova(lm(PC~Bedingung*P_Typ+id*Bedingung*P_Typ,data=data.PC))
# Bayes Factor:
# main effect Bedingung...SSE1 = 0.23873 SSE0 = 0.23873+0.00648
# delta BIC= n * ln (SSE1/SSE0)+(k1-k0)*ln(n)
deltaBIC<-(34* log(0.23873/(0.23873+0.00648)))+(1*log(34))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... no evidence (H1) vs. positive (H0)
BF
# main effect P_Typ...SSE1 = 1.75228 SSE0 = 1.75228+1.30522
# delta BIC= n * ln (SSE1/SSE0)+(k1-k0)*ln(n)
deltaBIC<-(68* log(1.75228/(1.75228+1.30522)))+(2*log(68))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D #p_H1_D... very strong (H1) vs. no evidence(H0)

# interaction
anova(a<-lm(PC~P_Typ+id*P_Typ,data=data.PC[data.PC$Bedingung=="C",]))
deltaBIC<-(68* log(1.21446/(1.21446+0.42887)))+(2*log(68))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # p_H1_D... very strong (H1)
anova(a<-lm(PC~P_Typ+id*P_Typ,data=data.PC[data.PC$Bedingung=="E",]))
deltaBIC<-(68* log(1.00373/(1.00373+0.96211)))+(2*log(68))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # p_H1_D... very strong (H1)... Effekt von P_Typ in jeder Bedingung vorhanden

##################################################################################
data11<-subset(data1, korrekt==1)
data.RT <- cast(data11, value="RZ", id + Bedingung + P_Typ  ~ ., function(x) c(RT=mean(x), N=length(x)) )
summary(aov(RT ~ (Bedingung*P_Typ)+Error(id/(Bedingung*P_Typ)), data=data.RT))
anova(lm(RT~Bedingung*P_Typ+id*Bedingung*P_Typ,data=data.RT))
library(MASS)
boxcox(RT~Bedingung,data=data.RT)
#anova(lm(RT^(-0.5)~Bedingung*P_Typ+id*Bedingung*P_Typ,data=data.RT))

# Bayes Factor:
deltaBIC<-(34* log(1.4662/(1.4662+0.0102)))+(1*log(34))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... no evidence (H1) vs. positive (H0)
BF 

# comparable to Experiment 2 all Probes have 1 or none repeated features)
data1.PC <- cast(data1[data1$festeMerkmale>=2,], value="korrekt", id + Bedingung + P_Typ  ~ ., function(x) c(PC=mean(x), N=length(x)) )
summary(aov(PC ~ Bedingung*P_Typ+Error(id/Bedingung*P_Typ), data=data1.PC))
anova(lm(PC~Bedingung*P_Typ+id*Bedingung*P_Typ,data=data1.PC))
# Bayes Factor:
deltaBIC<-(34* log(0.32970/(0.32970+0.000264)))+(1*log(34))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... no evidence (H1) vs. positive (H0)

data1.RT <- cast(data11[data11$festeMerkmale>=2,], value="RZ", id + Bedingung + P_Typ  ~ ., function(x) c(RT=mean(x), N=length(x)) )
summary(aov(RT ~ Bedingung*P_Typ+Error(id/Bedingung*P_Typ), data=data1.RT))
anova(lm(RT~Bedingung*P_Typ+id*Bedingung*P_Typ,data=data1.RT))
# Bayes Factor:
deltaBIC<-(34* log(1.9717/(1.9717+0.0036)))+(1*log(34))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... no evidence (H1) vs. positive (H0)

##########################################################################################
# data Experiment 2 (choose the right path)
setwd("C:/Users/Elisabeth/Desktop/PMR2/Experiment2")
data2<- read.table("data2.txt", header = TRUE);
colnames(data2) = c("Vpn","Geschlecht","Alter","Ausbildung","WT","ZST","farbschwach","Nr", "Bedingung","P_Typ","P_Ort","I1_Form","I1_Farbe","I1_Textur","I2_Form","I2_Farbe","I2_Textur","I3_Form","I3_Farbe","I3_Textur","I4_Form","I4_Farbe","I4_Textur","P_Form","P_Farbe","P_Textur","RZ","korrekt")
## data
dim(data2)
head(data2)

data2$id <- factor(data2$Vpn)
data2$Bedingung <- factor(data2$Bedingung, labels=c("C", "E"))
data2$P_Typ<-factor(data2$P_Typ, labels=c("positive", "new","swap"))

data22<-subset(data2,korrekt==1)
# ANOVAs
data2.PC <- cast(data2, value="korrekt", id + Bedingung +P_Typ  ~ ., function(x) c(PC=mean(x), N=length(x)) )
summary(aov(PC ~ Bedingung*P_Typ+Error(id/Bedingung*P_Typ), data=data2.PC))
anova(lm(PC~Bedingung*P_Typ+id*Bedingung*P_Typ,data=data2.PC))
# Bayes Factor:
deltaBIC<-(29* log(0.34562/(0.34562+0.02255)))+(1*log(29))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... no evidence (H1) vs. weak (H0)
BF
data2.RT <- cast(data22, value="RZ", id + Bedingung + P_Typ  ~ ., function(x) c(RT=mean(x), N=length(x)) )
summary(aov(RT ~ Bedingung*P_Typ+Error(id/Bedingung*P_Typ), data=data2.RT))
anova(lm(RT~Bedingung*P_Typ+id*Bedingung*P_Typ,data=data2.RT))
# Bayes Factor:
deltaBIC<-(29* log(0.5491/(0.5491+0.0422)))+(1*log(29))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... no evidence (H1) vs. weak (H0)
BF
#########################################################################################
# Experiment 1 & 2 combined
data1.PC$Experiment<-1;data1.RT$Experiment<-1;
data2.PC$Experiment<-2;data2.RT$Experiment<-2;
data2.PC$id<-as.factor(c(rep(40:68, each = 6)));data2.RT$id<-as.factor(c(rep(40:68, each = 6)))

datPC<-rbind(data1.PC,data2.PC)
datRT<-rbind(data1.RT,data2.RT)

summary(aov(PC ~ Bedingung*P_Typ+Error(id/Bedingung*P_Typ), data=datPC))
anova(lm(PC~Bedingung*P_Typ+id*Bedingung*P_Typ,data=datPC))
# Bayes Factor:
deltaBIC<-(63* log(0.68101/(0.68101+0.01950)))+(1*log(63))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... no evidence (H1) vs. positive (H0)
BF

summary(aov(RT ~ Bedingung*P_Typ+Error(id/Bedingung*P_Typ), data=datRT))
anova(lm(RT~Bedingung*P_Typ+id*Bedingung*P_Typ,data=datRT))
# Bayes Factor:
deltaBIC<-(63* log(2.533/(2.533+0.034)))+(1*log(63))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... no evidence (H1) vs. positive (H0)

###################################################################################
# data Experiment 3 (choose the right path)
setwd("C:/Users/Elisabeth/Desktop/PMR2/Experiment3")
data3<- read.csv("data3.csv", header = TRUE);

## data
dim(data3)
head(data3)

data3$Bedingung <- factor(data3$Bed, labels = c("C","E"))

data3$Cond1[data3$Bedingung=="C"]<- 1
data3$Cond1[data3$Rep1==0 &data3$Bedingung=="E"]<- 1
data3$Cond1[data3$Rep1==1 &data3$Bedingung=="E"]<- 2

data3$Cond2[data3$Bedingung=="C"]<- 1
data3$Cond2[data3$Rep2==0 &data3$Bedingung=="E"]<- 1
data3$Cond2[data3$Rep2==1 &data3$Bedingung=="E"]<- 2

data3$Cond3[data3$Bedingung=="C"]<- 1
data3$Cond3[data3$Rep3==0 &data3$Bedingung=="E"]<- 1
data3$Cond3[data3$Rep3==1 &data3$Bedingung=="E"]<- 2

table(data3$Cond1[data3$korr1!=-1], data3$Bedingung[data3$korr1!=-1])              # check
table(data3$Cond2[data3$korr2!=-1], data3$Bedingung[data3$korr2!=-1]) 
table(data3$Cond3[data3$korr3!=-1], data3$Bedingung[data3$korr3!=-1]) 

# put all data together
a<-as.data.frame(cbind(data3$Vpn[data3$korr1!=-1],data3$korr1[data3$korr1!=-1],data3$Bedingung[data3$korr1!=-1],data3$Cond1[data3$korr1!=-1],data3$Typ[data3$korr1!=-1]<-"shape"))
b<-as.data.frame(cbind(data3$Vpn[data3$korr2!=-1],data3$korr2[data3$korr2!=-1],data3$Bedingung[data3$korr2!=-1],data3$Cond2[data3$korr2!=-1],data3$Typ[data3$korr2!=-1]<-"pattern"))
c<-as.data.frame(cbind(data3$Vpn[data3$korr3!=-1],data3$korr3[data3$korr3!=-1],data3$Bedingung[data3$korr3!=-1],data3$Cond3[data3$korr3!=-1],data3$Typ[data3$korr3!=-1]<-"color"))
colnames(a)<-c("id","korr","Bedingung","Cond","type")
colnames(b)<-c("id","korr","Bedingung","Cond","type")
colnames(c)<-c("id","korr","Bedingung","Cond","type")

dat<-rbind(a,b,c)
dat$korr<-as.numeric(dat$korr);dat$korr[dat$korr==1]<-0;dat$korr[dat$korr==2]<-1;
dat$id <- factor(dat$id)
dat$Bedingung<-factor(dat$Bed,labels=c("C","E"))
dat$type <- factor(dat$type)

dat$cond <- factor(paste(dat$Bedingung, dat$Cond, sep="_"))

# ANOVAs
dat.PC <- cast(dat, value="korr", id + cond+type ~ ., function(x) c(PC=mean(x), N=length(x)) )
summary(aov(PC ~ cond*type+Error(id/cond*type), data=dat.PC))
summary(aov(PC ~ cond+Error(id/cond), data=dat.PC))

anova(lm(PC~cond*type+id*cond*type,data=dat.PC))
# Bayes Factor:
deltaBIC<-(27* log(0.49112/(0.49112+0.88383)))+(1*log(27))
BF = exp(deltaBIC/2)
p_H0_D<-BF/(1+BF)
1-p_H0_D # = p_H1_D... very strong (H1) vs. no evidence (H0)

mean(dat$korr[dat$cond=="C_1"])
mean(dat$korr[dat$cond=="E_1"])
mean(dat$korr[dat$cond=="E_2"])
###########################################################
# Finish.
###########################################################
